
#include "TArtAlias.hh"
#include "TArtHistManager.hh"
#include "TArtCanvasManager.hh"
#include "TArtSimpleFunction.hh"
#include "TArtExec.hh"

void fetch(char* filename){TArtHistManager::ReadHist(filename);}
void hstore(char* filename){TArtHistManager::WriteHist(filename);}
void clear(){TArtHistManager::DeleteHist();}
void hdel(int id){TArtHistManager::DeleteHist(id);}
void hdel(int idstart, int idend){TArtHistManager::DeleteHist(idstart, idend);}

void ls(){TArtHistManager::PrintListOfHist();}

void ht(int idstart, int idend){cd(1);hht(idstart, idend);}
void ht(int id){cdn();hht(id);}
void htp(){cdn();hhtp();}
void hn(){cdn();hhn();}
void hb(){cdn();hhb();}

void hht(int idstart, int idend)
{for(int i = idstart; i <= idend && i-idstart < TArtCanvasManager::GetSubpadNumber(); ++i)
    {hht(i);cdn();}}
void hht(int id){TArtHistManager::DrawHist(id);}
void hhtp(){TArtHistManager::DrawCurrentHist();}
void hhn(){TArtHistManager::DrawNextHist();}
void hhb(){TArtHistManager::DrawPreviousHist();}

void lg(){lgx();lgy();lgz();}
void ln(){lnx();lny();lnz();}
void lgx(){TArtCanvasManager::SetLogx(1);}
void lgy(){TArtCanvasManager::SetLogy(1);}
void lgz(){TArtCanvasManager::SetLogz(1);}
void lnx(){TArtCanvasManager::SetLogx(0);}
void lny(){TArtCanvasManager::SetLogy(0);}
void lnz(){TArtCanvasManager::SetLogz(0);}

void size(UInt_t ww, UInt_t wh){TArtCanvasManager::SetWindowSize(ww, wh);}
void cd(Int_t subpadnumber){TArtCanvasManager::cd(subpadnumber);}
void cdn(){TArtCanvasManager::cdNext();}
void cdb(){TArtCanvasManager::cdPrev();}
void zone(Int_t nx, Int_t ny, Float_t xmargin, Float_t ymargin, Int_t color)
{TArtCanvasManager::Divide(nx, ny, xmargin, ymargin, color);}

Double_t xval(){return TArtExec::GXValue();}
Double_t yval(){return TArtExec::GYValue();}
void xyval(){Double_t x,y;TArtExec::GXYValue(x,y);}
void zoom(){TArtSimpleFunction::GRange();}
void unzoom(){TArtSimpleFunction::Range();}
void blow(){TArtSimpleFunction::GBlow();}
void hsta(){TArtSimpleFunction::StatusHist();}
void xsta(){TArtSimpleFunction::GStatusX();}
void cpro(){TArtSimpleFunction::CutGHist();}
TFitResultPtr xfitp(int n){return TArtSimpleFunction::GFitPolynomial(n);}
TFitResultPtr xfite(){return TArtSimpleFunction::GFitExponential();}
TFitResultPtr xfitg(){return TArtSimpleFunction::GFitGaussian();}
TFitResultPtr xfitl(){return TArtSimpleFunction::GFitLandau();}

void figa(){fitg();}
TFitResultPtr fit(const char* formula, Option_t* option, Option_t* goption, Double_t xmin, Double_t xmax){return TArtSimpleFunction::Fit(formula, option, goption, xmin, xmax);}
TFitResultPtr fitp(int n, Double_t xmin, Double_t xmax, Option_t* option, Option_t* goption){return TArtSimpleFunction::FitPolynomial(n, option, goption, xmin, xmax);}
TFitResultPtr fite(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TArtSimpleFunction::FitExponential(option, goption, xmin, xmax);}
TFitResultPtr fitg(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TArtSimpleFunction::FitGaussian(option, goption, xmin, xmax);}
TFitResultPtr fitl(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TArtSimpleFunction::FitLandau(option, goption, xmin, xmax);}

void chbin(Int_t ngroupx, Int_t ngroupy, Int_t ngroupz){TArtSimpleFunction::ChangeBin(ngroupx, ngroupy, ngroupz);}

void pfx(){TArtSimpleFunction::ProfileX();}
void pfy(){TArtSimpleFunction::ProfileY();}
void prx(){TArtSimpleFunction::ProjectionX();}
void pry(){TArtSimpleFunction::ProjectionY();}
void slx(Int_t num){TArtSimpleFunction::SliceX(num);}
void sly(Int_t num){TArtSimpleFunction::SliceY(num);}
void bnx(double firsty, double lasty, Option_t* option){TArtSimpleFunction::BanX(firsty, lasty, option);}
void bny(double firstx, double lastx, Option_t* option){TArtSimpleFunction::BanY(firstx, lastx, option);}
void blowxyz(double firstx, double lastx, double firsty, double lasty, double firstz, double lastz)
{TArtSimpleFunction::Blow(firstx, lastx, firsty, lasty, firstz, lastz);}
void blowx(double firstx, double lastx){TArtSimpleFunction::BlowX(firstx, lastx);}
void blowy(double firsty, double lasty){TArtSimpleFunction::BlowY(firsty, lasty);}
void blowz(double firstz, double lastz){TArtSimpleFunction::BlowZ(firstz, lastz);}

void scale(Double_t c){TArtSimpleFunction::Scale(c);}
void add(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TArtSimpleFunction::Add(id1, id2, c1, c2);}
void multiply(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TArtSimpleFunction::Multiply(id1, id2, c1, c2);}
void divide(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TArtSimpleFunction::Divide(id1, id2, c1, c2);}

void mami(double min, double max){TArtSimpleFunction::MinMax(min, max);}
//void watch(void (*fpt)(), UInt_t milliSec, Int_t num){TArtSimpleFunction::Watch(fpt, milliSec, num);}

void print(char* filename, Option_t* option){TArtCanvasManager::SaveAs(filename, option);}


TH1* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup)
{return TArtSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup);}
TH2* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t valy, Int_t nbinsy, Double_t ylow, Double_t yup)
{return TArtSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup);}
TH3* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t valy, Int_t nbinsy, Double_t ylow, Double_t yup,
	      Double_t valz, Int_t nbinsz, Double_t zlow, Double_t zup)
{return TArtSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup,
					      valz, nbinsz, zlow, zup);}
TH1* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup)
{return TArtSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup);}
TH2* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t* valy, Int_t nbinsy, Double_t ylow, Double_t yup)
{return TArtSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup);}
TH3* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t* valy, Int_t nbinsy, Double_t ylow, Double_t yup,
	      Double_t* valz, Int_t nbinsz, Double_t zlow, Double_t zup)
{return TArtSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup,
					      valz, nbinsz, zlow, zup);}

void readobject(char* filename){TArtSimpleFunction::ReadObjectFromFile(filename);}
void writeobject(char* filename){TArtSimpleFunction::WriteObjectToFile(filename);}
void writehisttotext(char* filename){TArtSimpleFunction::WriteHistToText(filename);}
void createhist(char* filename){TArtSimpleFunction::CreateHistFromText(filename);}
void creategraph(char* filename){TArtSimpleFunction::CreateGraphFromText(filename);}
TH1* gethist(int id){return TArtHistManager::GetHist(id);}
void setoption(Option_t* option){TArtHistManager::SetDefaultOption(option);}
